//-------------------------------------------------------------------------------
// FILE: SAMPLE17.CPP
//
// Juli 98 sample for How Do I in OS/2 e-Zine!
//
// Created by Eric Slaats
// File created with Smalled 2.00.01a
//-------------------------------------------------------------------------------
#define  INCL_WIN
#include <os2.h>

#include "sample17.h"

//-------------------------------------------------------------------------------
//Dialog Window procedure prototype
//-------------------------------------------------------------------------------
MRESULT EXPENTRY DlgProc ( HWND, ULONG ,MPARAM, MPARAM );

//-------------------------------------------------------------------------------
// Global vars
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
// Main
//
// Sets up a simple dialogbox to demonstrate that a dialog can act as a main
// window
// By using a dialog none of the usual window control has to be included.
// Everything exept the coupling of the menu is done in a dialog editor.
//-------------------------------------------------------------------------------
void main(void)
	{
	HAB hab = WinInitialize(0);
	HMQ hmq = WinCreateMsgQueue(hab,0);

	WinDlgBox(HWND_DESKTOP,
			HWND_DESKTOP,
			DlgProc,
			NULLHANDLE,
			DIALOG1,
			0);

	WinDestroyMsgQueue(hmq);
	WinTerminate(hab);
	}


//---------------------------------------------------------------------------------
// dialog procedure
//---------------------------------------------------------------------------------
MRESULT EXPENTRY DlgProc(HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
	{
	switch (msg)
		{
		//-----------------------------------------------------------------------
		// Handle the initialization of the dialog
		//-----------------------------------------------------------------------
		case WM_INITDLG:
			{
			}
		break;


		//-----------------------------------------------------------------------
		// Handle WM_COMMAND
		//-----------------------------------------------------------------------
		case WM_COMMAND:
			{
			//------------------------------------------------------------------
			// Handle the buttons
			//------------------------------------------------------------------
			switch (SHORT1FROMMP(mp1))
				{
				case 1001: DosBeep(1000,100); break;
				case 1002: DosBeep(2000,100); break;
				case 1003: DosBeep(4000,100); break;
				case 1004: DosBeep(8000,100); break;
				}
			}
		return(0);

		case WM_CONTEXTMENU:
			{
			HWND hwndPopup;                    // popuphandle
			hwndPopup = WinLoadMenu(hwndDlg, NULLHANDLE, POPUP1);   // load popup
			WinPopupMenu(hwndDlg,                                   // Start popup
					   hwndDlg,
					   hwndPopup,
					   SHORT1FROMMP(mp1),
					   SHORT2FROMMP(mp1),
					   0,
					   PU_HCONSTRAIN | PU_VCONSTRAIN | PU_MOUSEBUTTON1 | PU_KEYBOARD);
			}
		return (MRFROMLONG(TRUE));
		}
	return WinDefDlgProc(hwndDlg, msg, mp1, mp2);
	}

